library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;


entity address_counter is
	generic (N : integer := 4);
   port(
		  clk, reset, incr : in  std_logic; 
		  size             : in std_logic_vector(N-1 downto 0);--12 downto 0---------------------------------------------------------------------------
        q : out std_logic_vector(N-1 downto 0)
		 ); 
end address_counter;

architecture rtl of address_counter is 
  signal teller: std_logic_vector(N-1 downto 0) := (OTHERS => '0');
  begin 
      process (clk)
        begin 
		  if (clk'event and clk='1') then 
			if (reset='1') then 
            teller <= (OTHERS => '0'); 
			end if;
				if(incr = '1') then
					  if(teller = size - 1) then
						teller <= (OTHERS => '0');
					else
						teller <= teller + 1;
					end if;
				end if;
			end if; 
      end process;
      q <= teller; 
end rtl;