library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity address_counter_test is
end;

architecture BENCH of address_counter_test is

 component address_counter
   generic (N : integer);
   port(
		  clk, reset, incr : in  std_logic; 
		  size             : in std_logic_vector(3 downto 0);
        q : out std_logic_vector(N-1 downto 0)
		 ); 
  end component;

  signal reset, clk, incr : STD_LOGIC;
  signal size : std_logic_vector(3 downto 0);
  constant bit_width : integer := 4;
 
  signal q : std_logic_vector(bit_width-1 downto 0);
  constant period : Time := 10 NS;
  signal temp_clk : std_logic := '1';
begin

  reset <= '1', '0' after 30 NS;
  size <= "0010";
  incr <= '0', '1' after 50 NS, '0' after 100 NS, '1' after 150 NS;

    clk <= temp_clk;
   
	clk_process : process(clk, temp_clk)
   begin
		  temp_clk  <= not temp_clk after 5 NS;
	end process;
  
  address_counter1 : address_counter 
  GENERIC MAP (N => bit_width)
  PORT MAP (
		clk => clk,
		reset	 => reset,
		incr	 => incr,
		size   => size,
		q	 => q
	);

end BENCH;