library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity calculate_size_test is
end entity calculate_size_test;

architecture rtl of calculate_size_test is

component calculate_size
     port
   (
		clk, reset, start : in std_logic;
		size : in std_logic_vector(3 downto 0);
		done : out std_logic;
		size1, size2 : out std_logic_vector(3 downto 0)
   );
end component;

signal reset, clk, start : std_logic;
signal	size : std_logic_vector(3 downto 0);
signal	done : std_logic;
signal	size1, size2 : std_logic_vector(3 downto 0);
signal temp_clk : std_logic := '1';

begin

reset <= '1', '0' after 20 NS;
size <= "0011", "1110" after 140 NS;
start <= '0', '1' after 50 NS, '0' after 60 NS, '1' after 150 NS, '0' after 160 NS;
clk <= temp_clk;
   
   clk_process : process(clk, temp_clk)
   begin
	  temp_clk  <= not temp_clk after 5 NS;
	end process;
	
	calculate_size1 : calculate_size PORT MAP (
		clk => clk,
		reset => reset,
		start => start,
		size => size,
		done => done,
		size1 => size1,
		size2 => size2
		);
end rtl;