LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY control_shift_reg IS
generic (length : integer := 2
			);
PORT (
	clk 		: 			IN STD_LOGIC;
	reset    :        IN STD_LOGIC;
	inn 		: 			IN STD_LOGIC;
	ut 		: 			OUT STD_LOGIC
);
END control_shift_reg;

ARCHITECTURE rtl OF control_shift_reg IS

--SUBTYPE sr_width IS STD_LOGIC_VECTOR(63 DOWNTO 0);
TYPE sr_length IS ARRAY (length-1 DOWNTO 0) OF std_logic;

SIGNAL sr : sr_length;

BEGIN
	process (clk, reset)
begin
	if(reset = '1') then
		sr(0) <= '0';
		for i in 1 to length-1 loop
			sr(i) <= '0';
		end loop;

	elsif (rising_edge(clk)) then
			-- Shift data by one stage; data from last stage is lost
			sr((length-1) downto 1) <= sr((length-2) downto 0);

			-- Load new data into the first stage
			sr(0) <= inn;
	end if;
end process;

-- Capture the data from the last stage, before it is lost
ut <= sr(length-1);

END rtl;