library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;


entity counter is
	generic (bit_teller : integer := 3);
   port(
		  clk, reset, incr : in  std_logic; 
        q : out std_logic
		 ); 
end counter;

architecture rtl of counter is 
  signal teller: std_logic_vector(bit_teller-1 downto 0);
  signal q_temp : std_logic;
  begin 
      process (clk)
        begin 
		  if (clk'event and clk='1') then 
          if (reset='1') then 
            teller <= (OTHERS => '0'); 
          else
				if(incr = '1') then
					if(teller = (teller'range => '1')) then
						teller <= (OTHERS => '0');
						q_temp <= '1';
					else
						teller <= teller + 1;
						q_temp <= '0';
					end if;
				end if;
			 end if;
			end if;
      end process;
      q <= q_temp; 
end rtl;