library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity counter_test is
end;

architecture BENCH of counter_test is

 component counter
   generic (bit_teller : integer);
   port(
		  clk, reset, incr : in  std_logic; 
        q : out std_logic
		 ); 
  end component;

  signal reset, clk, incr : STD_LOGIC;
  constant bit_width : integer := 3;
 
  signal q : std_logic;
  constant period : Time := 10 NS;
  signal temp_clk : std_logic := '1';
begin

  reset <= '1', '0' after 30 NS;
  incr <= '0', '1' after 50 NS, '0' after 100 NS, '1' after 150 NS;

    clk <= temp_clk;
   
	clk_process : process(clk, temp_clk)
   begin
		  temp_clk  <= not temp_clk after 5 NS;
	end process;
  
  counter1 : counter 
  GENERIC MAP (bit_teller => bit_width)
  PORT MAP (
		clk => clk,
		reset	 => reset,
		incr	 => incr,
		q	 => q
	);

end BENCH;