LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY data_shift_reg IS
generic (length : integer := 13
			);
PORT (
	clk 		: 			IN STD_LOGIC;
	inn 		: 			IN STD_LOGIC_VECTOR(63 DOWNTO 0);
	ut 		: 			OUT STD_LOGIC_VECTOR(63 DOWNTO 0)
);
END data_shift_reg;

ARCHITECTURE rtl OF data_shift_reg IS

SUBTYPE sr_width IS STD_LOGIC_VECTOR(63 DOWNTO 0);
TYPE sr_length IS ARRAY (length-1 DOWNTO 0) OF sr_width;

SIGNAL temp : sr_length;

BEGIN
	PROCESS (clk)
	BEGIN
		IF (clk'EVENT and clk = '1') THEN
			temp(length-2 DOWNTO 0) <= temp(length-1 DOWNTO 1);
			temp(length-1) <= inn;
		END IF;
	END PROCESS;
	
	ut <= temp(0);

END rtl;