library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity fill_memory_control_test is
end entity fill_memory_control_test;

architecture rtl of fill_memory_control_test is

component fill_memory_control
     port
   (
		clk, reset, start : in std_logic;
		size : in std_logic_vector(3 downto 0);
		wr_memory1, wr_memory2 : out std_logic;
		done : out std_logic
   );
end component;

signal reset, clk, start : std_logic;
signal	size : std_logic_vector(3 downto 0);
signal	done : std_logic;
signal wr_memory1, wr_memory2 : std_logic;
signal temp_clk : std_logic := '1';

begin

reset <= '1', '0' after 20 NS;
size <= "0011";
start <= '0', '1' after 50 NS, '0' after 60 NS, '1' after 150 NS, '0' after 160 NS;
clk <= temp_clk;
   
   clk_process : process(clk, temp_clk)
   begin
	  temp_clk  <= not temp_clk after 5 NS;
	end process;
	
	fill_memory_control1 : fill_memory_control PORT MAP (
		clk => clk,
		reset => reset,
		start => start,
		size => size,
		wr_memory1 => wr_memory1,
		wr_memory2 => wr_memory2,
		done => done
		);
end rtl;