library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
 
entity int_ram_shell is
   port
   (
		inndata	: in std_logic_vector(63 downto 0);
	   clk, reset : in std_logic;
		wren, rden : in std_logic;
		size  : in std_logic_vector(12 downto 0);--12 downto 0--------------------------------------------------------------------------------------------
		utdata : out std_logic_vector(63 downto 0)
   );
end entity int_ram_shell;

architecture rtl of int_ram_shell is
	
	component address_counter
		generic (N : integer := 4);
		port(
		  clk, reset, incr : in  std_logic; 
		  size             : in std_logic_vector(12 downto 0);--12 downto 0------------------------------------------------------------------------------------
        q 					 : out std_logic_vector(N-1 downto 0)
		 ); 
	end component;
	
	component ram_test_komp
    port (
				aclr		: IN STD_LOGIC  := '0';
				clock		: IN STD_LOGIC  := '1';
				data		: IN STD_LOGIC_VECTOR (63 DOWNTO 0);
				rdaddress		: IN STD_LOGIC_VECTOR (12 DOWNTO 0);
				rden		: IN STD_LOGIC  := '1';
				wraddress		: IN STD_LOGIC_VECTOR (12 DOWNTO 0);
				wren		: IN STD_LOGIC  := '0';
				q		: OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
			);
   end component;
	
	signal wire1, wire2 : std_logic;
	signal wire3, wire4 : std_logic_vector(12 downto 0);--12 downto 0------------------------------------------------------------------------------------------------
	constant N : integer := 13;
	
	begin
		
		ram1 : ram_test_komp PORT MAP (
			aclr	 => reset,
			clock => clk,
			data	 => inndata,
			rdaddress	 => wire4,
			rden	 => rden,
			wraddress => wire3,
			wren => wren,
			q => utdata
		);
		
		read_address_counter : address_counter 
		GENERIC MAP (N => N)
		PORT MAP (
			clk => clk,
			reset => reset,
			incr => rden,--wire1,
			size => size,
			q => wire4
		);
		
		write_address_counter : address_counter 
		GENERIC MAP (N => N)
		PORT MAP (
			clk => clk,
			reset => reset,
			incr => wren,--wire2,
			size => size,
			q => wire3
		);
	end rtl;
	