library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity int_ram_shell_test is
end;

architecture BENCH of int_ram_shell_test is
--component
	component int_ram_shell
		port
		(
			inndata	: in std_logic_vector(63 downto 0);
			clk, reset, wren, rden : in std_logic;
			size  : in std_logic_vector(3 downto 0);
			utdata : out std_logic_vector(63 downto 0)
		);
		end component;
--signal
			signal inndata, utdata		 : std_logic_vector(63 downto 0); 
			signal reset, clk, wren, rden : std_logic;
			signal size : std_logic_vector(3 downto 0);
			signal temp_clk : std_logic := '1';
			constant period : Time := 10 NS;
begin
--stimuli
  reset <= '1', '0' after 30 NS;

  wren <= '0', '1' after 50 NS, '0' after 100 NS, '1' after 150 NS, '0' after 200 NS;
  rden <= '0', '1' after 100 NS, '0' after 150 NS, '1' after 200 NS, '0' after 250 NS;
  size <= "0101";
  
  --1 til 22
  inndata <= x"3FF0000000000000", x"4000000000000000" after 50 NS, x"4008000000000000" after 60 NS, x"4010000000000000" after 70 NS, x"4014000000000000" after 80 NS, x"4018000000000000" after 90 NS , x"401C000000000000" after 100 NS, x"4020000000000000" after 110 NS, x"4022000000000000" after 120 NS, x"4024000000000000" after 130 NS, x"4026000000000000" after 140 NS, x"4028000000000000" after 150 NS, x"402A000000000000" after 160 NS, x"402C000000000000" after 170 NS, x"402E000000000000" after 180 NS, x"4030000000000000" after 190 NS, x"4031000000000000" after 200 NS, x"4032000000000000" after 210 NS, x"4033000000000000" after 220 NS, x"4034000000000000" after 230 NS, x"4035000000000000" after 240 NS, x"4036000000000000" after 250 NS;
  --clk_en7 <= '0', '1' after 40 NS;
  --start <= '0', '1' after 80 NS, '0' after 90 NS;
--  clk_en1 <= '0', '1' after 370 NS;
--  clk_en2 <= '0', '1' after 370 NS;
--  clk_en3 <= '0', '1' after 370 NS;
--  clk_en4 <= '0', '1' after 440 NS;
--  clk_en5 <= '0', '1' after 440 NS;
--  clk_en6 <= '0', '1' after 510 NS;
  
  clk <= temp_clk;
   
   clk_process : process(clk, temp_clk)
   begin
	  temp_clk  <= not temp_clk after 5 NS;
	end process;
	
--instansiate component
int_ram_shell1 : int_ram_shell PORT MAP (
		inndata	 => inndata,
		clk	 => clk,
		reset	 => reset,
		wren	 => wren,
		rden => rden,
		size => size,
		utdata	 => utdata
	);

end BENCH;