LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY shift_reg2 IS
generic (length : integer := 13
			);
PORT (
	clk 		: 			IN STD_LOGIC;
	inn 		: 			IN STD_LOGIC;
	tap1		:        OUT STD_LOGIC;
	ut 		: 			OUT STD_LOGIC
);
END shift_reg2;

ARCHITECTURE rtl OF shift_reg2 IS

--SUBTYPE sr_width IS STD_LOGIC_VECTOR(63 DOWNTO 0);
TYPE sr_length IS ARRAY (length-1 DOWNTO 0) OF std_logic;

SIGNAL temp : sr_length;

BEGIN
	PROCESS (clk)
	BEGIN
		IF (clk'EVENT and clk = '1') THEN
			temp(length-2 DOWNTO 0) <= temp(length-1 DOWNTO 1);
			temp(length-1) <= inn;
		END IF;
	END PROCESS;
	
	tap1 <= temp(7);
	ut <= temp(0);

END rtl;