library ieee;
use ieee.std_logic_1164.all;

entity shift_reg_en is

generic
(
length : integer := 12
);

port
(
	clk : in std_logic;
	reset : in std_logic;
	--enable : in std_logic;
	inn : in std_logic;
	ut : out std_logic
);

end entity shift_reg_en;

architecture rtl of shift_reg_en is

-- Build an array type for the shift register
type sr_length is array ((length-1) downto 0) of std_logic;

-- Declare the shift register signal
signal sr: sr_length;

begin

process (clk, reset)
begin
	if(reset = '1') then
		sr(0) <= '0';
		for i in 1 to length-1 loop
			sr(i) <= '0';
		end loop;

	elsif (rising_edge(clk)) then

	--if (enable = '1') then

		-- Shift data by one stage; data from last stage is lost
		sr((length-1) downto 1) <= sr((length-2) downto 0);

		-- Load new data into the first stage
		sr(0) <= inn;

	--end if;
	end if;
end process;

-- Capture the data from the last stage, before it is lost
ut <= sr(length-1);

end rtl;