LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
use ieee.std_logic_unsigned.all;

ENTITY top_control IS

PORT (
	clk 		: 			IN STD_LOGIC;
	reset    :        IN STD_LOGIC;
	size    :        IN STD_LOGIC_VECTOR(12 downto 0);---------12 downto 0--------------------------------
	start, done_matrix_vector_mult, done_rr, done_dq, done_division, done_size, done_fill_memory, finish, b_fifo_empty : in std_logic;
	d_sel1, d_sel2, d_sel3, d_sel4, d_sel5, d_sel9, d_sel10, d_sel11, d_sel12, d_sel13, d_sel14, d_sel15, d_sel16 		: 	OUT STD_LOGIC;
	c_sel1, c_sel2, d_sel6, d_sel7, d_sel8 : out std_logic_vector(1 downto 0);
   c_sel3, c_sel4, c_sel5, c_sel6, c_sel7, c_sel8, c_sel9, c_sel10 : out std_logic;
	control1, control2, start_matrix_vector_mult, start_dot_product, start_size, start_fill_memory, mode_dot_product, done : out std_logic;
	error : out std_logic_vector(63 downto 0);
	iteration_counter_out : out std_logic_vector(18 downto 0);
	b_fifo_read : out std_logic
	--size_read : out std_logic
	--size_empty : in std_logic
	--b_fifo_empty : in std_logic
);
END top_control;

ARCHITECTURE rtl OF top_control IS

	type state_type is (idle, init_state, calculate_rr_init_state, put_d_new_in_d_new_first_state, fill_memory_state, matrix_vector_state, calculate_dq_state, calculate_alfa_state, calculate_x_and_r_state, d_new_in_d_old_state, calculate_rr_state, stop_or_not_state, send_out_x_state, calculate_beta_state, calculate_d_state);
	--signal
	signal current_state, next_state : state_type;
	signal teller: std_logic_vector(12 downto 0);-- := (OTHERS => '0');--12 downto 0----------------------------------------------------------
	signal teller2 : std_logic_vector(14 downto 0);
	signal iteration_counter : std_logic_vector(18 downto 0);
	signal start_teller, reset_teller, start_teller2, reset_teller2, start_iteration_counter, reset_iteration_counter : std_logic;
	--signal d_new_reg : std_logic_vector(63 downto 0);
	--signal put_d_new_in_d_new_reg, reset_d_new_reg : std_logic;
	constant error_reg : std_logic_vector(63 downto 0) := x"3D06849B86A12B9B"; -- x"3E45798EE2308C3A";--=0.00000001x"3E112E0BE826D695";--=0.000000001 
	
	
	begin
		iteration_counter_out <= iteration_counter;
		error <= error_reg;
		
		process(clk, reset)--, start_teller, reset_teller)
		begin
			if(reset = '1') then
				current_state <= idle;--first_state;--fill_b_state;--idle;
				teller <= (OTHERS => '0');
				teller2 <= (OTHERS => '0');
				iteration_counter <= (OTHERS => '0');
			elsif(rising_edge(clk)) then
				current_state <= next_state;
				if(start_teller = '1') then
					teller <= teller + '1';
				--end if;
				elsif(reset_teller = '1') then
					teller <= (OTHERS => '0');
				end if;
				if(start_teller2 = '1') then
					teller2 <= teller2 + '1';
				end if;
				if(reset_teller2 = '1') then
					teller2 <= (OTHERS => '0');
				end if;
				if(start_iteration_counter = '1') then
					iteration_counter <= iteration_counter + 1;
				elsif(reset_iteration_counter = '1') then
					iteration_counter <= (OTHERS => '0');
				end if;
			end if;
		end process;
				
		process(current_state, start, done_matrix_vector_mult, done_rr, done_dq, done_division, size, teller, teller2, done_size, done_fill_memory, finish, b_fifo_empty)
		--variable teller1 : integer range 0 to 16;
		begin
			case current_state is
--				when first_state =>
--					done <= '0';
--					reset_teller <= '1';
--					start_teller <= '0';
--					reset_teller2 <= '1';
--					start_teller2 <= '0';
--					d_sel1 <= '0';
--					d_sel2 <= '0';
--					d_sel3 <= '0';
--					d_sel4 <= '0';
--					d_sel5 <= '0';
--					d_sel6 <= "01";
--					d_sel7 <= "01";
--					d_sel8 <= "01";
--					d_sel9 <= '0';
--					d_sel10 <= '0';
--					d_sel11 <= '0';
--					d_sel12 <= '0';
--					d_sel13 <= '0';
--					d_sel14 <= '0';
--					d_sel15 <= '0';
--					d_sel16 <= '0';
--					c_sel1 <= "00";
--					c_sel2 <= "01";
--					c_sel3 <= '0';
--					c_sel4 <= '0';
--					c_sel5 <= '0';
--					c_sel6 <= '0';
--					c_sel7 <= '0';
--					c_sel8 <= '0';
--					c_sel9 <= '0';
--					c_sel10 <= '0';
--					control1 <= '0';
--					control2 <= '0';
--					start_matrix_vector_mult <= '0';
--					start_dot_product <= '0';
--					start_size <= '0';
--					start_fill_memory <= '0';
--					mode_dot_product <= '0';
--					b_fifo_read <= '0';
--					next_state <= fill_b_state;
					
				
					
				when idle =>
					done <= '0';
					--reset_teller <= '1';
					--start_teller <= '0';
					reset_teller2 <= '1';
					start_teller2 <= '0';
					reset_iteration_counter <= '1';
					start_iteration_counter <= '0';
					d_sel1 <= '0';
					d_sel2 <= '0';
					d_sel3 <= '0';
					d_sel4 <= '0';
					d_sel5 <= '0';
					d_sel6 <= "01";
					d_sel7 <= "01";
					d_sel8 <= "01";
					d_sel9 <= '0';
					d_sel10 <= '0';
					d_sel11 <= '0';
					d_sel12 <= '0';
					d_sel13 <= '0';
					d_sel14 <= '0';
					d_sel15 <= '0';
					d_sel16 <= '0';
					c_sel1 <= "00";
					c_sel2 <= "01";
					c_sel3 <= '0';
					c_sel4 <= '0';
					c_sel5 <= '0';
					c_sel6 <= '0';
					c_sel7 <= '0';
					c_sel8 <= '0';
					c_sel9 <= '0';
					c_sel10 <= '0';
					control1 <= '0';
					control2 <= '0';
					start_matrix_vector_mult <= '0';
					start_dot_product <= '0';
					start_size <= '0';
					start_fill_memory <= '0';
					mode_dot_product <= '0';
					--b_fifo_read <= '0';
					
					if(b_fifo_empty = '0') then
						b_fifo_read <= '1';
						if(teller = size-1) then --size-1
							--next_state <= init_state;--idle;
							--reset_teller <= '1';
							start_teller <= '0';
						else
						--	next_state <= fill_b_state;
							start_teller <= '1';
							--reset_teller <= '0';
						end if;
					else
						b_fifo_read <= '0';
						start_teller <= '0';
						--reset_teller <= '0';
						--next_state <= fill_b_state;
					end if;
--					if(size_empty = '0') then
--						size_read <= '1';
--					else
--						size_read <= '0';
--					end if;
					
					if(start = '1') then
						next_state <= init_state;--fill_b_state;--init_state;
						reset_teller <= '1';
					else
						next_state <= idle;
						reset_teller <= '0';
					end if;
					
--				when fill_b_state =>
--					done <= '0';
--					--reset_teller <= '0';
--					--start_teller <= '0';
--					reset_teller2 <= '1';
--					start_teller2 <= '0';
--					reset_iteration_counter <= '0';
--					start_iteration_counter <= '0';
--					d_sel1 <= '0';
--					d_sel2 <= '0';
--					d_sel3 <= '0';
--					d_sel4 <= '0';
--					d_sel5 <= '0';
--					d_sel6 <= "01";
--					d_sel7 <= "01";
--					d_sel8 <= "01";
--					d_sel9 <= '0';
--					d_sel10 <= '0';
--					d_sel11 <= '0';
--					d_sel12 <= '0';
--					d_sel13 <= '0';
--					d_sel14 <= '0';
--					d_sel15 <= '0';
--					d_sel16 <= '0';
--					c_sel1 <= "00";
--					c_sel2 <= "01";
--					c_sel3 <= '0';
--					c_sel4 <= '0';
--					c_sel5 <= '0';
--					c_sel6 <= '0';
--					c_sel7 <= '0';
--					c_sel8 <= '0';
--					c_sel9 <= '0';
--					c_sel10 <= '0';
--					control1 <= '0';
--					control2 <= '0';
--					start_matrix_vector_mult <= '0';
--					start_dot_product <= '0';
--					start_size <= '0';
--					start_fill_memory <= '0';
--					mode_dot_product <= '0';
--					--size_read <= '0';
--					if(b_fifo_empty = '0') then
--						b_fifo_read <= '1';
--						if(teller = size-1) then --size-1
--							next_state <= init_state;--idle;
--							reset_teller <= '1';
--							start_teller <= '0';
--						else
--							next_state <= fill_b_state;
--							start_teller <= '1';
--							reset_teller <= '0';
--						end if;
--					else
--						b_fifo_read <= '0';
--						start_teller <= '0';
--						reset_teller <= '0';
--						next_state <= fill_b_state;
--					end if;
					
					
				when init_state =>
					done <= '0';
					reset_teller2 <= '1';
					start_teller2 <= '0';
					reset_iteration_counter <= '0';
					start_iteration_counter <= '0';
					d_sel1 <= '0';
					d_sel2 <= '0';
					d_sel3 <= '0';
					d_sel4 <= '0';
					d_sel5 <= '0';
					d_sel6 <= "01";
					d_sel7 <= "01";
					d_sel8 <= "01";
					d_sel9 <= '0';
					d_sel10 <= '0';
					d_sel11 <= '0';
					d_sel12 <= '0';
					d_sel13 <= '0';
					d_sel14 <= '0';
					d_sel15 <= '1';--Legger error inn i registeret
					d_sel16 <= '0';
					c_sel2 <= "01";
					c_sel3 <= '0';
					c_sel4 <= '0';
					c_sel5 <= '0';
					c_sel6 <= '0';
					c_sel7 <= '0';
					c_sel8 <= '0';
					c_sel9 <= '1';
					c_sel10 <= '1';
					--control1 <= '0';
					control2 <= '0';
					start_matrix_vector_mult <= '0';
					start_dot_product <= '0';
					mode_dot_product <= '0';
					start_fill_memory <= '0';
					b_fifo_read <= '0';
				--	size_read <= '0';
					if(teller = "0000000000000") then
						start_size <= '1';
					else
						start_size <= '0';
					end if;
					if(teller < size) then
						c_sel1 <= "01";
						control1 <= '1';
						start_teller <= '1';
						--reset_teller <= '0';
						--next_state <= init_state;
					else
						c_sel1 <= "00";
						control1 <= '0';
						start_teller <= '0';
						--next_state <= calculate_rr_init_state;
						--reset_teller <= '1';
					end if;
					if(done_size = '1') then
						next_state <= calculate_rr_init_state;
						reset_teller <= '1';
					else
						next_state <= init_state;
						reset_teller <= '0';
					end if;
				
				when calculate_rr_init_state =>
					done <= '0';
					reset_teller2 <= '1';
					start_teller2 <= '0';
					reset_iteration_counter <= '0';
					start_iteration_counter <= '0';
					d_sel1 <= '0';
					d_sel2 <= '0';
					d_sel3 <= '0';
					d_sel4 <= '0';
					d_sel5 <= '0';
					d_sel6 <= "01";
					d_sel7 <= "11";
					d_sel8 <= "11";
					d_sel9 <= '0';
					d_sel10 <= '0';
					d_sel11 <= '0';
					d_sel12 <= '0';
					d_sel13 <= '0';
					d_sel14 <= '0';
					d_sel15 <= '0';
					d_sel16 <= '0';
					c_sel1 <= "00";
					c_sel2 <= "01";
					c_sel3 <= '0';
					c_sel4 <= '0';
					c_sel5 <= '0';
					c_sel6 <= '0';
					c_sel7 <= '0';
					c_sel8 <= '0';
					c_sel9 <= '0';
					c_sel10 <= '0';
					control2 <= '0';
					start_size <= '0';
					start_matrix_vector_mult <= '0';
					start_fill_memory <= '0';
					b_fifo_read <= '0';
					--size_read <= '0';
					
					if(teller = "0000000000000") then
						start_dot_product <= '1';
					else
						start_dot_product <= '0';
					end if;
					if(teller < size) then
						start_teller <= '1';
						control1 <= '1';
					else
						control1 <= '0';
						start_teller <= '0';
					end if;
					mode_dot_product <= '1';
					
					if(done_rr = '1') then
						next_state <= put_d_new_in_d_new_first_state;--fill_memory_state;
						reset_teller <= '1';
					else
						next_state <= calculate_rr_init_state;
						reset_teller <= '0';
					end if;
					
			when put_d_new_in_d_new_first_state =>
					done <= '0';
					reset_teller <= '1';
					start_teller <= '0';
					reset_teller2 <= '1';
					start_teller2 <= '0';
					reset_iteration_counter <= '0';
					start_iteration_counter <= '0';
					d_sel1 <= '0';
					d_sel2 <= '0';
					d_sel3 <= '0';
					d_sel4 <= '0';
					d_sel5 <= '0';
					d_sel6 <= "01";
					d_sel7 <= "01";
					d_sel8 <= "01";
					d_sel9 <= '0';
					d_sel10 <= '0';
					d_sel11 <= '0';
					d_sel12 <= '0';
					d_sel13 <= '0';
					d_sel14 <= '1';
					d_sel15 <= '0';
					d_sel16 <= '0';
					c_sel1 <= "00";
					c_sel2 <= "01";
					c_sel3 <= '0';
					c_sel4 <= '0';
					c_sel5 <= '0';
					c_sel6 <= '0';
					c_sel7 <= '0';
					c_sel8 <= '0';
					c_sel9 <= '0';
					c_sel10 <= '0';
					control1 <= '0';
					control2 <= '0';
					start_matrix_vector_mult <= '0';
					start_dot_product <= '0';
					start_size <= '0';
					start_fill_memory <= '0';
					mode_dot_product <= '0';
					b_fifo_read <= '0';
					--size_read <= '0';
					next_state <= fill_memory_state;
				
			when fill_memory_state =>
					done <= '0';
					reset_teller2 <= '1';
					start_teller2 <= '0';
					reset_iteration_counter <= '0';
					start_iteration_counter <= '0';
					d_sel1 <= '0';
					d_sel2 <= '0';
					d_sel3 <= '0';
					d_sel4 <= '0';
					d_sel5 <= '0';
					d_sel6 <= "01";
					d_sel7 <= "01";
					d_sel8 <= "01";
					d_sel9 <= '0';
					d_sel10 <= '0';
					d_sel11 <= '0';
					d_sel12 <= '0';
					d_sel13 <= '1';
					d_sel14 <= '0';
					d_sel15 <= '0';
					d_sel16 <= '0';
					c_sel1 <= "00";
					c_sel2 <= "01";
					c_sel3 <= '0';
					c_sel4 <= '0';
					c_sel5 <= '0';
					c_sel6 <= '1';
					c_sel7 <= '0';
					c_sel8 <= '0';
					c_sel9 <= '0';
					c_sel10 <= '0';
				--	control1 <= '0';
					control2 <= '0';
					start_matrix_vector_mult <= '0';
					start_dot_product <= '0';
					start_size <= '0';
					--start_fill_memory <= '0';
					mode_dot_product <= '0';
					b_fifo_read <= '0';
					--size_read <= '0';
					if(teller = "0000000000000") then
						start_fill_memory <= '1';
					else
						start_fill_memory <= '0';
					end if;
					if(teller < size) then
						start_teller <= '1';
						control1 <= '1';
					else
						control1 <= '0';
						start_teller <= '0';
					end if;
					if(done_fill_memory = '1') then
						next_state <= matrix_vector_state;
						reset_teller <= '1';
					else
						next_state <= fill_memory_state;
						reset_teller <= '0';
					end if;
				
			when matrix_vector_state =>
					done <= '0';
					reset_teller2 <= '1';
					start_teller2 <= '0';
					reset_iteration_counter <= '0';
					start_iteration_counter <= '0';
					d_sel1 <= '0';
					d_sel2 <= '0';
					d_sel3 <= '0';
					d_sel4 <= '0';
					d_sel5 <= '0';
					d_sel6 <= "01";
					d_sel7 <= "01";
					d_sel8 <= "01";
					d_sel9 <= '0';
					d_sel10 <= '0';
					d_sel11 <= '0';
					d_sel12 <= '0';
					d_sel13 <= '0';
					d_sel14 <= '0';
					d_sel15 <= '0';
					d_sel16 <= '0';
					c_sel1 <= "00";
					c_sel2 <= "01";
					c_sel3 <= '0';
					c_sel4 <= '0';
					c_sel5 <= '0';
					c_sel6 <= '0';
					c_sel7 <= '0';
					c_sel8 <= '0';
					c_sel9 <= '0';
					c_sel10 <= '0';
					control1 <= '0';
					control2 <= '0';
					start_dot_product <= '0';
					start_size <= '0';
					mode_dot_product <= '0';
					start_fill_memory <= '0';
					b_fifo_read <= '0';
					--size_read <= '0';
					
					if(teller = "0000000000000") then
						start_matrix_vector_mult <= '1';
					else
						start_matrix_vector_mult <= '0';
					end if;
					
					if(teller < size) then
						start_teller <= '1';
					else
						start_teller <= '0';
					end if;
					
					if(done_matrix_vector_mult = '1') then
						next_state <= calculate_dq_state;
						reset_teller <= '1';
					else
						next_state <= matrix_vector_state;
						reset_teller <= '0';
					end if;
					
				when calculate_dq_state =>
					done <= '0';
					reset_teller2 <= '1';
					start_teller2 <= '0';
					reset_iteration_counter <= '0';
					start_iteration_counter <= '0';
					d_sel1 <= '0';
					d_sel2 <= '0';
					d_sel3 <= '0';
					d_sel4 <= '0';
					d_sel5 <= '0';
					d_sel6 <= "01";
					d_sel7 <= "00";
					d_sel8 <= "00";
					d_sel9 <= '0';
					d_sel10 <= '0';
					d_sel11 <= '0';
					d_sel12 <= '0';
					d_sel13 <= '0';
					d_sel14 <= '0';
					d_sel15 <= '0';
					d_sel16 <= '0';
					c_sel1 <= "00";
					c_sel2 <= "01";
					c_sel3 <= '0';
					c_sel4 <= '0';
					c_sel5 <= '0';
					c_sel6 <= '1';
					c_sel7 <= '1';
					c_sel8 <= '0';
					c_sel9 <= '0';
					c_sel10 <= '0';
					control2 <= '0';
					start_matrix_vector_mult <= '0';
					start_size <= '0';
					mode_dot_product <= '0';--dq
					start_fill_memory <= '0';
					b_fifo_read <= '0';
					--size_read <= '0';
					
					if(teller = "0000000000000") then
						start_dot_product <= '1';
					else
						start_dot_product <= '0';
					end if;
					if(teller < size) then
						start_teller <= '1';
						control1 <= '1';
					else
						control1 <= '0';
						start_teller <= '0';
					end if;
					
					if(done_dq = '1') then
						next_state <= calculate_alfa_state;
						reset_teller <= '1';
					else
						next_state <= calculate_dq_state;
						reset_teller <= '0';
					end if;
					
				when calculate_alfa_state =>
					done <= '0';
					reset_teller2 <= '1';
					start_teller2 <= '0';
					reset_iteration_counter <= '0';
					start_iteration_counter <= '0';
					d_sel1 <= '0';
					d_sel2 <= '0';
					d_sel3 <= '0';
					d_sel4 <= '0';
					d_sel5 <= '0';
					d_sel7 <= "01";
					d_sel8 <= "01";
					d_sel9 <= '0';
					d_sel10 <= '0';
					d_sel11 <= '0';
					d_sel13 <= '0';
					d_sel14 <= '0';
					d_sel15 <= '0';
					d_sel16 <= '0';
					c_sel1 <= "00";
					c_sel2 <= "01";
					c_sel3 <= '0';
					c_sel4 <= '0';
					c_sel5 <= '0';
					c_sel6 <= '0';
					c_sel7 <= '0';
					c_sel8 <= '0';
					c_sel9 <= '0';
					c_sel10 <= '0';
					control1 <= '0';
					start_matrix_vector_mult <= '0';
					start_size <= '0';
					start_dot_product <= '0';
					mode_dot_product <= '0';
					start_fill_memory <= '0';
					b_fifo_read <= '0';
					--size_read <= '0';
					
					if(teller = "0000000000000") then
						d_sel6 <= "00";
						d_sel12 <= '1';
						control2 <= '1';
						start_teller <= '1';
					else
						d_sel6 <= "01";
						d_sel12 <= '0';
						control2 <= '0';
						start_teller <= '0';
					end if;
					
					if(done_division = '1') then
						next_state <= calculate_x_and_r_state;
						reset_teller <= '1';
					else
						next_state <= calculate_alfa_state;
						reset_teller <= '0';
					end if;
					
				when calculate_x_and_r_state =>
					reset_iteration_counter <= '0';
					start_iteration_counter <= '0';
					done <= '0';
					d_sel3 <= '0';
					d_sel5 <= '0';
					d_sel6 <= "01";
					d_sel7 <= "01";
					d_sel8 <= "01";
					d_sel12 <= '0';
					d_sel13 <= '0';
					d_sel14 <= '0';
					d_sel15 <= '0';
					d_sel16 <= '0';
					c_sel5 <= '0';
					c_sel9 <= '0';
					c_sel10 <= '0';
					control2 <= '0';
					start_matrix_vector_mult <= '0';
					start_size <= '0';
					start_dot_product <= '0';
					mode_dot_product <= '0';
					start_fill_memory <= '0';
					b_fifo_read <= '0';
					--size_read <= '0';
					
					if(teller < size) then
						control1 <= '1';
						start_teller <= '1';
					else
						control1 <= '0';
						start_teller <= '0';
					end if;
					
					if(teller2 < ("00" & size) + "000000000011011") then---MULT_LAT+ADD_LAT+2---"001110"--------------------------------------------------------------------------------
						d_sel1 <= '1';
						d_sel2 <= '1';
						d_sel4 <= '1';
						d_sel9 <= '1';
						d_sel10 <= '1';
						d_sel11 <= '1';
						c_sel1 <= "11";
						c_sel2 <= "11";
						c_sel3 <= '1';
						c_sel4 <= '1';
						c_sel6 <= '1';
						c_sel7 <= '1';
						c_sel8 <= '1';
						reset_teller <= '0';
						start_teller2 <= '1';
						reset_teller2 <= '0';
						next_state <= calculate_x_and_r_state;
					else
						d_sel1 <= '0';
						d_sel2 <= '0';
						d_sel4 <= '0';
						d_sel9 <= '0';
						d_sel10 <= '0';
						d_sel11 <= '0';
						c_sel1 <= "00";
						c_sel2 <= "01";
						c_sel3 <= '0';
						c_sel4 <= '0';
						c_sel6 <= '0';
						c_sel7 <= '0';
						c_sel8 <= '0';
						start_teller2 <= '0';
						reset_teller2 <= '1';
						reset_teller <= '1';
						next_state <= d_new_in_d_old_state;
					end if;
					
				when d_new_in_d_old_state =>
					done <= '0';
					reset_teller <= '1';
					start_teller <= '0';
					reset_teller2 <= '1';
					start_teller2 <= '0';
					reset_iteration_counter <= '0';
					start_iteration_counter <= '0';
					d_sel1 <= '0';
					d_sel2 <= '0';
					d_sel3 <= '0';
					d_sel4 <= '0';
					d_sel5 <= '1';------------------------
					d_sel6 <= "01";
					d_sel7 <= "01";
					d_sel8 <= "01";
					d_sel9 <= '0';
					d_sel10 <= '0';
					d_sel11 <= '0';
					d_sel12 <= '0';
					d_sel13 <= '0';
					d_sel14 <= '0';
					d_sel15 <= '0';
					d_sel16 <= '0';
					c_sel1 <= "00";
					c_sel2 <= "01";
					c_sel3 <= '0';
					c_sel4 <= '0';
					c_sel5 <= '0';
					c_sel6 <= '0';
					c_sel7 <= '0';
					c_sel8 <= '0';
					c_sel9 <= '0';
					c_sel10 <= '0';
					control1 <= '0';
					control2 <= '0';
					start_matrix_vector_mult <= '0';
					start_size <= '0';
					start_dot_product <= '0';
					mode_dot_product <= '0';
					start_fill_memory <= '0';
					next_state <= calculate_rr_state;
					b_fifo_read <= '0';
					--size_read <= '0';
					
				when calculate_rr_state =>
					done <= '0';
					reset_teller2 <= '1';
					start_teller2 <= '0';
					reset_iteration_counter <= '0';
					d_sel1 <= '0';
					d_sel2 <= '0';
					d_sel3 <= '0';
					d_sel4 <= '0';
					d_sel5 <= '0';
					d_sel6 <= "01";
					d_sel7 <= "11";
					d_sel8 <= "11";
					d_sel9 <= '0';
					d_sel10 <= '0';
					d_sel11 <= '0';
					d_sel12 <= '0';
					d_sel13 <= '0';
					d_sel14 <= '0';
					d_sel15 <= '0';
					d_sel16 <= '0';
					c_sel1 <= "00";
					c_sel2 <= "01";
					c_sel3 <= '0';
					c_sel4 <= '0';
					c_sel5 <= '0';
					c_sel6 <= '0';
					c_sel7 <= '0';
					c_sel8 <= '0';
					c_sel9 <= '0';
					c_sel10 <= '0';
					control2 <= '0';
					start_matrix_vector_mult <= '0';
					start_size <= '0';
					start_fill_memory <= '0';
					b_fifo_read <= '0';
					--size_read <= '0';
					
					if(teller = "0000000000000") then
						start_dot_product <= '1';
						start_iteration_counter <= '1';
					else
						start_dot_product <= '0';
						start_iteration_counter <= '0';
					end if;
					if(teller < size) then
						start_teller <= '1';
						control1 <= '1';
					else
						control1 <= '0';
						start_teller <= '0';
					end if;
					mode_dot_product <= '1';
					
					if(done_rr = '1') then
						next_state <= stop_or_not_state;--calculate_beta_state;
						reset_teller <= '1';
					else
						next_state <= calculate_rr_state;
						reset_teller <= '0';
					end if;
					
				when stop_or_not_state =>
					reset_teller2 <= '1';
					start_teller2 <= '0';
					reset_iteration_counter <= '0';
					start_iteration_counter <= '0';
					d_sel1 <= '0';
					d_sel2 <= '0';
					d_sel3 <= '0';
					d_sel4 <= '0';
					d_sel5 <= '0';
					d_sel6 <= "01";
					d_sel7 <= "01";
					d_sel8 <= "01";
					d_sel9 <= '0';
					d_sel10 <= '0';
					d_sel11 <= '0';
					d_sel12 <= '0';
					d_sel13 <= '0';
					d_sel14 <= '0';
					d_sel15 <= '0';
					d_sel16 <= '0';
					c_sel1 <= "00";
					c_sel2 <= "01";
					c_sel3 <= '0';
					c_sel4 <= '0';
					c_sel5 <= '0';
					c_sel6 <= '0';
					c_sel7 <= '0';
					c_sel8 <= '0';
					c_sel9 <= '0';
					c_sel10 <= '0';
					control1 <= '0';
					control2 <= '0';
					start_matrix_vector_mult <= '0';
					start_dot_product <= '0';
					start_size <= '0';
					start_fill_memory <= '0';
					mode_dot_product <= '0';
					--size_read <= '0';
					
					b_fifo_read <= '0';
					if(teller = "0000000000100") then
						if(finish = '1') then
							done <= '1';
							next_state <= send_out_x_state;
							reset_teller <= '1';
							start_teller <= '0';
						else
							next_state <= calculate_beta_state;
							done <= '0';
							reset_teller <= '1';
							start_teller <= '0';
						end if;
					else
						next_state <= stop_or_not_state;
						done <= '0';
						reset_teller <= '0';
						start_teller <= '1';
					end if;
					
				when send_out_x_state =>
					done <= '0';
				   reset_iteration_counter <= '0';
					start_iteration_counter <= '0';
					reset_teller2 <= '1';
					start_teller2 <= '0';
					d_sel1 <= '0';
					d_sel2 <= '0';
					d_sel3 <= '0';
					d_sel4 <= '0';
					d_sel5 <= '0';
					d_sel6 <= "01";
					d_sel7 <= "01";
					d_sel8 <= "01";
					d_sel9 <= '0';
					d_sel10 <= '0';
					d_sel11 <= '0';
					d_sel12 <= '0';
					d_sel13 <= '0';
					d_sel14 <= '0';
					d_sel15 <= '0';
					--d_sel16 <= '1';
					c_sel1 <= "00";
					c_sel2 <= "00";
					c_sel3 <= '0';
					c_sel4 <= '0';
					c_sel5 <= '0';
					c_sel6 <= '0';
					c_sel7 <= '0';
					c_sel8 <= '0';
					c_sel9 <= '0';
					c_sel10 <= '0';
					--control1 <= '0';
					control2 <= '0';
					start_matrix_vector_mult <= '0';
					start_dot_product <= '0';
					start_size <= '0';
					start_fill_memory <= '0';
					mode_dot_product <= '0';
					b_fifo_read <= '0';
					--size_read <= '0';
					if(teller < size) then
						start_teller <= '1';
						reset_teller <= '0';
						d_sel16 <= '1';
						control1 <= '1';
						next_state <= send_out_x_state;
					else
						d_sel16 <= '0';
						control1 <= '0';
						start_teller <= '0';
						reset_teller <= '1';
						next_state <= idle;
					end if;
					
				when calculate_beta_state =>
					reset_teller2 <= '1';
					start_teller2 <= '0';
					reset_iteration_counter <= '0';
					start_iteration_counter <= '0';
					done <= '0';
					d_sel1 <= '0';
					d_sel2 <= '0';
					d_sel3 <= '0';
					d_sel4 <= '0';
					d_sel5 <= '0';
					d_sel7 <= "01";
					d_sel8 <= "01";
					d_sel9 <= '0';
					d_sel10 <= '0';
					d_sel11 <= '0';
					d_sel13 <= '0';
					d_sel14 <= '0';
					d_sel15 <= '0';
					d_sel16 <= '0';
					c_sel1 <= "00";
					c_sel2 <= "01";
					c_sel3 <= '0';
					c_sel4 <= '0';
					c_sel5 <= '0';
					c_sel6 <= '0';
					c_sel7 <= '0';
					c_sel8 <= '0';
					c_sel9 <= '0';
					c_sel10 <= '0';
					control1 <= '0';
					start_matrix_vector_mult <= '0';
					start_size <= '0';
					start_dot_product <= '0';
					mode_dot_product <= '0';
					start_fill_memory <= '0';
					b_fifo_read <= '0';
					--size_read <= '0';
					
					if(teller = "0000000000000") then
						d_sel6 <= "11";
						d_sel12 <= '1';
						control2 <= '1';
						start_teller <= '1';
					else
						d_sel6 <= "01";
						d_sel12 <= '0';
						control2 <= '0';
						start_teller <= '0';
					end if;
					
					if(done_division = '1') then
						next_state <= calculate_d_state;
						reset_teller <= '1';
					else
						next_state <= calculate_beta_state;
						reset_teller <= '0';
					end if;
					
				when calculate_d_state =>
				   reset_iteration_counter <= '0';
					start_iteration_counter <= '0';
					done <= '0';
					d_sel1 <= '0';
					d_sel2 <= '0';
					d_sel5 <= '0';
					d_sel6 <= "01";
					d_sel7 <= "01";
					d_sel8 <= "01";
					d_sel10 <= '0';
					d_sel12 <= '0';
					d_sel13 <= '0';
					d_sel14 <= '0';
					d_sel15 <= '0';
					d_sel16 <= '0';
					c_sel1 <= "00";
					c_sel2 <= "01";
					c_sel3 <= '0';
					c_sel7 <= '0';
					c_sel9 <= '0';
					c_sel10 <= '0';
					control2 <= '0';
					start_matrix_vector_mult <= '0';
					start_size <= '0';
					start_dot_product <= '0';
					mode_dot_product <= '0';
					start_fill_memory <= '0';
					b_fifo_read <= '0';
					--size_read <= '0';
					
					if(teller < size) then
						control1 <= '1';
						start_teller <= '1';
					else
						control1 <= '0';
						start_teller <= '0';
					end if;
					
					if(teller2 < ("00" & size) + "000000000011011") then--ADD_LATENCY+MULT_LATENCY+2
						d_sel3 <= '1';
						d_sel4 <= '0';
						d_sel9 <= '1';
						d_sel11 <= '1';
						c_sel4 <= '1';
						c_sel5 <= '1';
						c_sel6 <= '1';
						c_sel8 <= '1';
						reset_teller <= '0';
						start_teller2 <= '1';
						reset_teller2 <= '0';
						next_state <= calculate_d_state;
					else
						d_sel3 <= '0';
						d_sel4 <= '1';
						d_sel9 <= '0';
						d_sel11 <= '0';
						c_sel4 <= '0';
						c_sel5 <= '0';
						c_sel6 <= '0';
						c_sel8 <= '0';
						start_teller2 <= '0';
						reset_teller2 <= '1';
						reset_teller <= '1';
						next_state <= fill_memory_state;
					end if;
				end case;
			end process;
		end rtl;
					
				
					