library IEEE;
use IEEE.STD_LOGIC_1164.all;
use ieee.std_logic_unsigned.all;

entity top_test is
	
end entity top_test;

architecture rtl of top_test is

component top
     port
   (
      inndata_fifo1, inndata_fifo2, data_b : std_logic_vector(63 downto 0);
		clk, fifo_clk : in std_logic;
		reset_inn, start_inn : in std_logic_vector(0 downto 0);
		size : in std_logic_vector(12 downto 0);
		wr_fifo1, wr_fifo2, wr_b, result_fifo_read : in std_logic;
		fifo1_full, fifo2_full, b_fifo_full, reset_full, start_full, result_fifo_empty, done : out std_logic;
		wrusedw1, wrusedw2 : out std_logic_vector(7 downto 0);
		result : out std_logic_vector(63 downto 0)
   );
end component;

 signal inndata_fifo1, inndata_fifo2, data_b, result :  std_logic_vector(63 downto 0); 
 
 signal clk, fifo_clk, wr_fifo1, wr_fifo2, wr_b, result_fifo_read, result_fifo_empty : std_logic; 
 signal fifo1_full, fifo2_full, b_fifo_full, done : std_logic;
 signal wrusedw1, wrusedw2 : std_logic_vector(7 downto 0);
 signal reset_full, start_full : std_logic;
 signal size : std_logic_vector(12 downto 0);--12 downto 0--------------------------------------------------------------------------------------------------------------
 signal reset_inn, start_inn : std_logic_vector(0 downto 0);
 signal temp_clk : std_logic := '1';
 --signal temp_clk2 : std_logic := '1';
 constant period : Time := 10 NS;
 
 begin
 --1  : 3FF0000000000000
 --2  : 4000000000000000
 --3  : 4008000000000000
 --4  : 4010000000000000
 --5  : 4014000000000000
 --6  : 4018000000000000
 --7  : 401C000000000000
 --8  : 4020000000000000
 --10 : 4024000000000000
 --19 : 4033000000000000
 --22 : 4036000000000000
 
 --A= [4008 4000 3FF0]
 --   [4000 4010 4008]
 --   [3FF0 4008 4014]
 
 --d= [3FF0 4000 4008]
 
 --q= [4024 4033  4036]
 --start_size <= '0', '1' after 40 NS, '0' after 120 NS;
 wr_b <=  '0', '1' after 100 NS, '0' after 130 NS;
 data_b <= x"0000000000000000", x"3FF0000000000000" after 100 NS, x"4000000000000000" after 110 NS, x"4008000000000000" after 120 NS;
 start_inn(0) <= '0', '1' after 140 NS, '0' after 150 NS;
 wr_fifo1 <= '0', '1' after 150 NS, '0' after 160 NS, '1' after 170 NS, '0' after 190 NS, '1' after 200 NS, '0' after 220 NS, '1' after 230 NS, '0' after 240 NS, '1' after 3150 NS, '0' after 3160 NS, '1' after 3170 NS, '0' after 3190 NS, '1' after 3200 NS, '0' after 3220 NS, '1' after 3230 NS, '0' after 3240 NS, '1' after 8150 NS, '0' after 8160 NS, '1' after 8170 NS, '0' after 8190 NS, '1' after 8200 NS, '0' after 8220 NS, '1' after 8230 NS, '0' after 8240 NS;--, '1' after 230 NS, '0' after 240 NS;
 wr_fifo2 <= '0', '1' after 160 NS, '0' after 170 NS, '1' after 190 NS, '0' after 200 NS, '1' after 220 NS, '0' after 230 NS, '1' after 3160 NS, '0' after 3170 NS, '1' after 3190 NS, '0' after 3200 NS, '1' after 3220 NS, '0' after 3230 NS, '1' after 8160 NS, '0' after 8170 NS, '1' after 8190 NS, '0' after 8200 NS, '1' after 8220 NS, '0' after 8230 NS;--, '1' after 220 NS, '0' after 230 NS;
 --wr_fifo1 <= '0', '1' after 150 NS, '0' after 160 NS, '1' after 170 NS, '0' after 180 NS, '1' after 190 NS, '0' after 200 NS, '1' after 210 NS, '0' after 220 NS, '1' after 230 NS, '0' after 240 NS, '1' after 250 NS, '0' after 260 NS, '1' after 270 NS, '0' after 280 NS, '1' after 290 NS, '0' after 300 NS;--, '1' after 230 NS, '0' after 240 NS;
 --wr_fifo2 <= '0', '1' after 160 NS, '0' after 170 NS, '1' after 180 NS, '0' after 190 NS, '1' after 200 NS, '0' after 210 NS, '1' after 220 NS, '0' after 230 NS, '1' after 240 NS, '0' after 250 NS, '1' after 260 NS, '0' after 270 NS, '1' after 280 NS, '0' after 290 NS, '1' after 300 NS, '0' after 310 NS;
 --inndata_fifo1 <= x"0000000000000000", x"4010000000000000" after 150 NS, x"4000000000000000" after 170 NS, x"4018000000000000" after 190 NS, x"4014000000000000" after 210 NS, x"4000000000000000" after 230 NS, x"4018000000000000" after 250 NS, x"3FF0000000000000" after 270 NS, x"4000000000000000" after 290 NS;--, x"4020000000000000" after 210 NS, x"4022000000000000" after 220 NS, x"4024000000000000" after 230 NS, x"4026000000000000" after 240 NS, x"4028000000000000" after 250 NS, x"402A000000000000" after 260 NS, x"402C000000000000" after 270 NS;
 --inndata_fifo2 <= x"0000000000000000", x"4018000000000000" after 160 NS, x"3FF0000000000000" after 180 NS, x"4020000000000000" after 200 NS, x"4008000000000000" after 220 NS, x"4014000000000000" after 240 NS, x"4000000000000000" after 260 NS, x"4008000000000000" after 280 NS, x"401C000000000000" after 300 NS;--, x"4022000000000000" after 220 NS, x"4024000000000000" after 230 NS, x"4026000000000000" after 240 NS, x"4028000000000000" after 250 NS, x"402A000000000000" after 260 NS, x"402C000000000000" after 270 NS;
 inndata_fifo1 <= x"0000000000000000", x"4008000000000000" after 150 NS, x"3FF0000000000000" after 170 NS, x"4000000000000000" after 180 NS, x"4008000000000000" after 200 NS, x"3FF0000000000000" after 210 NS, x"4014000000000000" after 230 NS, x"4008000000000000" after 3150 NS, x"3FF0000000000000" after 3170 NS, x"4000000000000000" after 3180 NS, x"4008000000000000" after 3200 NS, x"3FF0000000000000" after 3210 NS, x"4014000000000000" after 3230 NS, x"4008000000000000" after 8150 NS, x"3FF0000000000000" after 8170 NS, x"4000000000000000" after 8180 NS, x"4008000000000000" after 8200 NS, x"3FF0000000000000" after 8210 NS, x"4014000000000000" after 8230 NS;--, x"4018000000000000" after 190 NS , x"401C000000000000" after 200 NS, x"4020000000000000" after 210 NS, x"4022000000000000" after 220 NS, x"4024000000000000" after 230 NS, x"4026000000000000" after 240 NS, x"4028000000000000" after 250 NS, x"402A000000000000" after 260 NS, x"402C000000000000" after 270 NS;
 inndata_fifo2 <= x"0000000000000000", x"4000000000000000" after 160 NS, x"4010000000000000" after 190 NS, x"4008000000000000" after 220 NS, x"4000000000000000" after 3160 NS, x"4010000000000000" after 3190 NS, x"4008000000000000" after 3220 NS, x"4000000000000000" after 8160 NS, x"4010000000000000" after 8190 NS, x"4008000000000000" after 8220 NS;--, x"4008000000000000" after 220 NS;--, x"4014000000000000" after 180 NS, x"4018000000000000" after 190 NS , x"401C000000000000" after 200 NS, x"4020000000000000" after 210 NS, x"4022000000000000" after 220 NS, x"4024000000000000" after 230 NS, x"4026000000000000" after 240 NS, x"4028000000000000" after 250 NS, x"402A000000000000" after 260 NS, x"402C000000000000" after 270 NS;
 
 --wr_memory1 <= '0', '1' after 300 NS, '0' after 310 NS, '1' after 320 NS, '0' after 330 NS, '1' after 1600 NS, '0' after 1610 NS, '1' after 1620 NS, '0' after 1630 NS, '1' after 4200 NS, '0' after 4210 NS, '1' after 4220 NS, '0' after 4230 NS;--, '1' after 80 NS, '0' after 90 NS, '1' after 100 NS, '0' after 110 NS, '1' after 120 NS, '0' after 130 NS, '1' after 140 NS, '0' after 150 NS;
 --wr_memory2 <= '0', '1' after 310 NS, '0' after 320 NS, '1' after 1610 NS, '0' after 1620 NS, '1' after 4210 NS, '0' after 4220 NS;--, '1' after 70 NS, '0' after 80 NS;--, '1' after 70 NS, '0' after 80 NS, '1' after 90 NS, '0' after 100 NS, '1' after 110 NS, '0' after 120 NS, '1' after 130 NS, '0' after 140 NS;--, '0' after 150 NS; 
 --inndata_memory1 <= x"3FF0000000000000" after 300 NS, x"4008000000000000" after 320 NS, x"BFCAE365E1454267" after 1600 NS, x"3FD68B76E63C0A66" after 1620 NS, x"3FBFF71F7E5E552A" after 4200 NS, x"3FACA02B7CA0E508" after 4220 NS;--, x"4014000000000000" after 80 NS, x"401C000000000000" after 100 NS, x"4022000000000000" after 120 NS, x"4026000000000000" after 140 NS;--, x"402A000000000000" after 160 NS;
 --inndata_memory2 <= x"4000000000000000" after 310 NS, x"BFD30753EA40C4A7" after 1610 NS, x"BFC0B2C408B3305F" after 4210 NS;--, x"4010000000000000" after 70 NS;--, x"4010000000000000" after 70 NS, x"4018000000000000" after 90 NS, x"4020000000000000" after 110 NS, x"4024000000000000" after 130 NS;--	, x"4028000000000000" after 150 NS, x"402C000000000000" after 170 NS;
 
 reset_inn(0) <= '1', '0' after 30 NS;
 
 size <= "0000000000011";
  
 clk <= temp_clk;
 --fifo_clk <= temp_clk;  
   
	clk_process : process(clk, temp_clk)
   begin
	  temp_clk  <= not temp_clk after 5 NS;
	end process;
	
--	clk_process2 : process(fifo_clk, temp_clk2)
--   begin
--	  temp_clk2  <= not temp_clk2 after 5 NS;
--	end process;
	
	top1 : top PORT MAP (
		inndata_fifo1 => inndata_fifo1,
		inndata_fifo2 => inndata_fifo2,
		data_b => data_b,
		start_inn => start_inn,
		reset_inn => reset_inn,
		clk => clk,
		fifo_clk => clk,
		wr_fifo1 => wr_fifo1,
		wr_fifo2 => wr_fifo2,
		wr_b => wr_b,
		result_fifo_read => result_fifo_read,
		result_fifo_empty => result_fifo_empty,
		fifo1_full => fifo1_full,
		fifo2_full => fifo2_full,
		reset_full => reset_full, 
		start_full => start_full,
		size => size,
		done => done,
		wrusedw1 => wrusedw1,
		wrusedw2 => wrusedw2,
		result => result
		);
end rtl;