library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity top_top_test is
end entity top_top_test;

architecture rtl of top_top_test is

component top_top
port
   (
		reset, clk, start : in std_logic;
		size1 : in std_logic_vector(3 downto 0);
		size2 : in std_logic_vector(7 downto 0);
		done  : out std_logic;
		result : out std_logic_vector(63 downto 0)
   );
end component;

signal reset, clk, start, done : std_logic;
signal size1 : std_logic_vector(3 downto 0);
signal size2 : std_logic_vector(7 downto 0);
signal result : std_logic_vector(63 downto 0);
signal temp_clk : std_logic := '1';

begin



clk <= temp_clk;
   
   clk_process : process(clk, temp_clk)
   begin
	  temp_clk  <= not temp_clk after 5 NS;
	end process;
	
	reset <= '1', '0' after 20 NS;
	size1 <= "0100";
	size2 <= "00010000";
	start <= '0', '1' after 50 NS, '0' after 60 NS;
	
	top_top1 : top_top PORT MAP (
		reset => reset,
		clk => clk,
		start => start,
		size1 => size1,
		size2 => size2,
		done => done,
		result => result
		);
end rtl;