#include "assert.h"
#include <string.h>

template<class T>

class Row {
public:
	Row(int cols=0):row(NULL) {SetRowSize(cols);}
	
	~Row() {SetRowSize(0); }

	Row(const Row &r):row(NULL) {
		SetRowSize(r.numCols);
		for (int i=0;i<numCols;i++)
			row[i]=r.row[i];
	}

	void SetRowSize(int n) {
		if(row) delete[] row;
		if (n>0) {
			row=new T[n];
			memset(row,0,sizeof(T)*n/sizeof(char));
		}
		else row=NULL;
		numCols=n;
	}

	T& operator[](int column) {
		assert(column<numCols);
		return row[column];
	} 

	Row& operator=(const Row& r) {
		SetRowSize(r.numCols);
		for (int i=0;i<numCols;i++)
			row[i]=r.row[i];
		return *this;
	}


	int size() { return numCols;}
private:
	int numCols;
	T* row;
}; 